;************************************************
;*              GB Lemon tracker
;*		    LP1 297a
;*
;*              lemon@urbanet.ch
;*          http://www.gbdev.org/lemon
;*
;*    ASMotor  version Tomasz 'dox' Slanina
;*             dox@emugaming.com
;*
;************************************************

l_tempo equ 7			; change the tempo speed here

include "hardware.inc"

l_voice_start:
  ld [l_voice],a
  ld c,a
  ld hl,l_data_song_ptr
  ld a,[hl+]
  ld e,a
  ld d,[hl]
  ld a,[l_step]
  add a,a
  add a,a
  ld l,a
  ld h,0
  ld b,h
  add hl,bc
  add hl,hl
  add hl,de
  ld a,[hl+]
  ld [l_data_song],a
  ld e,a
  ld a,[hl]
  ld [l_data_song+1],a
  ld d,a
  srl a
  ld [l_gb_freq],a
  call l_effect_test
  ld a,[l_gb_freq]
  cp $48
  ret nz
  add sp,2
  ret

l_stopmusic:
  ld a,$8f
  ld [rNR52],a
  xor a
  ld [rNR51],a
  ld a,$77
  ld [rNR50],a
  ld a,$11
  ld [l_fx_pan0],a
  ld a,$22
  ld [l_fx_pan1],a
  ld a,$44
  ld [l_fx_pan2],a
  ld a,$88
  ld [l_fx_pan3],a
  ret

l_resetmusic:
  xor a
  ld [rNR52],a
  ld [l_step],a
  ld [l_patern],a
  ld a,$11
  ld [l_fx_pan0],a
  ld a,$22
  ld [l_fx_pan1],a
  ld a,$44
  ld [l_fx_pan2],a
  ld a,$88
  ld [l_fx_pan3],a
  ld a,$8f
  ld [rNR52],a
  xor a
  ld [rNR51],a
  ld a,$77
  ld [rNR50],a
  ret

lemon_init:
   call l_initdataL
   xor a
   ld [l_step],a
   ld [l_patern],a
   ld [l_clock],a
   call l_stopmusic
   call l_patern_definition
   ret

lemon_play:
   ld a,[l_clock]
   inc a
   cp l_tempo
   jr nz,.nz
   xor a
.nz:
  ld [l_clock],a
  ret nz

  ld a,9			; place the number of paterns here
  ld [l_nbr_patern],a
  call l_voice0
  call l_voice1
  call l_voice2
  call l_voice3
  ld a,[l_step]
  inc a
  cp 64
  jr nz,.n64
  ld a,[l_patern]
  inc a
  ld hl,l_nbr_patern
  cp [hl]
  jr c,.npat
  xor a
.npat:
  ld [l_patern],a
  xor a
.n64:
  ld [l_step],a
  call l_patern_definition
  ret


l_effect_test:
  ld a,[l_data_song]
  swap a
  and %11
  cp 1
  jp nz,.ne1
  ld a,[l_voice]
  or a
  jr nz,.nv0
  ld a,[l_data_song]
  and $f
  swap a
  ld [l_fx_value],a
  ld [l_fx_volume],a
  ld c,a
  ld a,[l_gb_freq]
  cp $48
  ret nz
  ld a,[l_snd_env0]
  and $f
  or c
  ld [rNR12],a
  ld a,[l_freqHI_v1]
  or $80
  ld [rNR14],a
  ret
.nv0:
  cp 1
  jr nz,.nv1
  ld a,[l_data_song]
  and $f
  swap a
  ld [l_fx_value],a
  ld [l_fx_volume],a
  ld c,a
  ld a,[l_gb_freq]
  cp $48
  ret nz
  ld a,[l_snd_env1]
  and $f
  or c
  ld [rNR22],a
  ld a,[l_freqHI_v2]
  or $80
  ld [rNR24],a
  ret
.nv1:
  cp 2
  jr nz,.nv2
  ld a,[l_data_song]
  and $f
  or a
  jr nz,.nfx0
  ld b,a
  jr .fxcd
.nfx0:
  cp 6
  jr nc,.nfx1
  ld b,$60
  jr .fxcd
.nfx1:
  cp 11
  jr nc,.nfx2
  ld b,$40
  jr .fxcd
.nfx2:
  ld b,$20
.fxcd:
  ld a,b
  ld [l_fx_value],a
  ld [l_fx_volume],a
  ld a,[l_gb_freq]
  cp $48
  ret nz
  ld a,b
  ld [rNR32],a
  ret

.nv2:
  ld a,[l_data_song]
  and $f
  swap a
  ld [l_fx_value],a
  ld [l_fx_volume],a
  ld c,a
  ld a,[l_gb_freq]
  cp $48
  ret nz
  ld a,[l_snd_env3]
  and $f
  or c ;fx_value
  ld [rNR42],a
  ld a,128
  ld [rNR44],a
  ret
.ne1:
  cp 2
  jp nz,.ne2
;pan effect
  ld a,[l_data_song]
  and $f
  ld [l_fx_value],a
  ld c,a
  ld a,[l_voice]
  or a,a
  jr nz,.x0
;voice=0
  ld a,c
  or a
  jr nz,.p1
  ld a,1
  jp .vx0
.p1:
  cp 8
  jr nz,.p2
  ld a,$11
  jp .vx0
.p2:
  cp $f
  jr nz,.vx0n
  ld a,$10
.vx0:
  ld [l_fx_pan0],a
.vx0n:
  ld a,[l_gb_freq]
  cp $48
  jp nz,.vx0_0
  ld hl,l_fx_pan0
  ld a,0
  or [hl];p0
  inc hl
  or [hl];p1
  inc hl
  or [hl];p2
  inc hl
  or [hl];p3
  ld [rNR51],a
.vx0_0:
  ld a,$f0
  ld [l_fx_volume],a
  ret
.x0:
  cp 1
  jr nz,.x1
;voice=1
  ld a,c
  or a
  jr nz,.p11
  ld a,2
  jp .vx01
.p11:
  cp 8
  jr nz,.p21
  ld a,$22
  jp .vx01
.p21:
  cp $f
  jr nz,.vx01n
  ld a,$20
.vx01:
  ld [l_fx_pan1],a
.vx01n:
  ld a,[l_gb_freq]
  cp $48
  jp nz,.vx0_01
  ld hl,l_fx_pan0
  ld a,0
  or [hl];p0
  inc hl
  or [hl];p1
  inc hl
  or [hl];p2
  inc hl
  or [hl];p3
  ld [rNR51],a
.vx0_01:
  ld a,$f0
  ld [l_fx_volume],a
  ret
.x1:
  cp 2
  jr nz,.x2
;voice=2
  ld a,c
  or a
  jr nz,.p12
  ld a,4
  jp .vx02
.p12:
  cp 8
  jr nz,.p22
  ld a,$44
  jp .vx02
.p22:
  cp $f
  jr nz,.vx02n
  ld a,$40
.vx02:
  ld [l_fx_pan2],a
.vx02n:
  ld a,[l_gb_freq]
  cp $48
  jp nz,.vx0_02
  ld hl,l_fx_pan0
  ld a,0
  or [hl];p0
  inc hl
  or [hl];p1
  inc hl
  or [hl];p2
  inc hl
  or [hl];p3
  ld [rNR51],a
.vx0_02:
  ld a,$20
  ld [l_fx_volume],a
  ret
.x2:
;voice=3
  ld a,c
  or a
  jr nz,.p13
  ld a,8
  jp .vx03
.p13:
  cp 8
  jr nz,.p23
  ld a,$88
  jp .vx03
.p23:
  cp $f
  jr nz,.vx03n
  ld a,$80
.vx03:
  ld [l_fx_pan3],a
.vx03n:
  ld a,[l_gb_freq]
  cp $48
  jp nz,.vx0_03
  ld hl,l_fx_pan0
  ld a,0
  or [hl];p0
  inc hl
  or [hl];p1
  inc hl
  or [hl];p2
  inc hl
  or [hl];p3
  ld [rNR51],a
.vx0_03:
  ld a,$f0
  ld [l_fx_volume],a
  ret
.ne2:
  or a
  ret nz
  ld b,$f0
  ld a,[l_voice]
  cp 2
  jr nz,.okvoice
  ld b,$20
.okvoice:
  ld a,b
  ld [l_fx_volume],a
  ret

l_instru_test:
  ld a,[l_data_song+1]
  ld c,a
  ld a,[l_data_song]
  swap a
  srl a
  srl a
  and %11
  bit 0,c
  jr z,.b0
  or %100
.b0;
  ld c,a
  ld a,[l_voice]
  or a
  jp nz,.nv0
  ld hl,l_snd_swp0
  ld a,c
  or a
  jr nz,.n00
;instrument 1 with sustain middle
  ld [hl],0
  inc hl
  ld [hl],7
  inc hl
  ld a,[l_fx_volume]
  or 2
  ld [hl+],a
  ld [hl],$80
  ret
.n00
  cp 1
  jr nz,.n01
;instrument 2 with sustain middle
  ld [hl],0
  inc hl
  ld [hl],$47
  inc hl
  ld a,[l_fx_volume]
  or 2
  ld [hl+],a
  ld [hl],$80
  ret
.n01
  cp 2
  jr nz,.n02
;instrument 3 with sustain middle
  ld [hl],0
  inc hl
  ld [hl],$87
  inc hl
  ld a,[l_fx_volume]
  or 2
  ld [hl+],a
  ld [hl],$80
  ret
.n02
  cp 3
  jr nz,.n03
;same as 1 with sustain infinite
  ld [hl],0
  inc hl
  ld [hl],7
  inc hl
  ld a,[l_fx_volume]
  ld [hl+],a
  ld [hl],$80
  ret
.n03
  cp 4
  jr nz,.n04
;same as 2 with sustain infinite
  ld [hl],0
  inc hl
  ld [hl],$47
  inc hl
  ld a,[l_fx_volume]
  ld [hl+],a
  ld [hl],$80
  ret
.n04
  cp 5
  jr nz,.n05
;same as 3 with sustain infinite
  ld [hl],0
  inc hl
  ld [hl],$87
  inc hl
  ld a,[l_fx_volume]
  ld [hl+],a
  ld [hl],$80
  ret
.n05
  cp 6
  cp c
  jr nz,.n06
;create your instrument 7 here
  ld [hl],0
  inc hl
  ld [hl],7
  inc hl
  ld a,[l_fx_volume]
  or 7
  ld [hl+],a
  ld [hl],$80
  ret
.n06
;create your instrument 8 here
  ld [hl],0
  inc hl
  ld [hl],7
  inc hl
  ld a,[l_fx_volume]
  or 7
  ld [hl+],a
  ld [hl],$80
  ret
.nv0:
  cp 1;voice
  jp nz,.nv1
  ld hl,l_snd_lngh1
  ld a,c
  or a
  jr nz,.n10
;instrument 1 with sustain middle
  ld [hl],0
  inc hl
  ld a,[l_fx_volume]
  or 2
  ld [hl+],a
  ld [hl],$80
  ret
.n10:
  cp 1
  jr nz,.n11
;instrument 2 with sustain middle
  ld [hl],$40
  inc hl
  ld a,[l_fx_volume]
  or 2
  ld [hl+],a
  ld [hl],$80
  ret
.n11:
  cp 2
  jr nz,.n12
;instrument 3 with sustain middle
  ld [hl],$80
  inc hl
  ld a,[l_fx_volume]
  or 2
  ld [hl+],a
  ld [hl],$80
  ret
.n12:
  cp 3
  jr nz,.n13
;same as 1 with sustain infinite
  ld [hl],0
  inc hl
  ld a,[l_fx_volume]
  ld [hl+],a
  ld [hl],$80
  ret
.n13:
  cp 4
  jr nz,.n14
;same as 2 with sustain infinite
  ld [hl],$40
  inc hl
  ld a,[l_fx_volume]
  ld [hl+],a
  ld [hl],$80
  ret
.n14:
  cp 5
  jr nz,.n15
;same as 3 with sustain infinite
  ld [hl],$80
  inc hl
  ld a,[l_fx_volume]
  ld [hl+],a
  ld [hl],$80
  ret
.n15:
  cp 6
  jr nz,.n16
;create your instrument 7 here
  ld [hl],$80
  inc hl
  ld a,[l_fx_volume]
  or 7
  ld [hl+],a
  ld [hl],$80
  ret
.n16:
;create your instrument 8 here
  ld [hl],$80
  inc hl
  ld a,[l_fx_volume]
  or 7
  ld [hl+],a
  ld [hl],$80
  ret
.nv1:
  cp 2;voice
  jp nz,.nv2
  swap c
  ld b,0
  ld hl,l_wave
  add hl,bc
  ld d,h
  ld e,l
  ld hl,$ff30
  ld c,16
.loop:
  ld a,[de]
  ld [hl+],a
  inc de
  dec c
  jr nz,.loop
  ret
.nv2:
  ld a,c
  ld hl,l_snd_lngh3
  or a,a
  jr nz,.n30
;bass drum
  ld [hl],1
  inc hl
  ld a,[l_fx_volume]
  or 1
  ld [hl+],a
  ld [hl],$55
  inc hl
  ld [hl],$80
  ret
.n30:
  cp 1
  jr nz,.n31
;hi hat
  ld [hl],1
  inc hl
  ld a,[l_fx_volume]
  or 1
  ld [hl+],a
  ld [hl],1
  inc hl
  ld [hl],$80
  ret
.n31:
  cp 2
  jr nz,.n32
;snare
  ld [hl],1
  inc hl
  ld a,[l_fx_volume]
  or 1
  ld [hl+],a
  ld [hl],$52
  inc hl
  ld [hl],$80
  ret
.n32:
  cp 3
  jr nz,.n33
;cymbal
  ld [hl],1
  inc hl
  ld a,[l_fx_volume]
  or 3
  ld [hl+],a
  ld [hl],2
  inc hl
  ld [hl],$80
  ret
.n33:
  cp 4
  jr nz,.n34
;laser tom high
  ld [hl],1
  inc hl
  ld a,[l_fx_volume]
  or 1
  ld [hl+],a
  ld [hl],$58
  inc hl
  ld [hl],$80
  ret
.n34:
  cp 5
  jr nz,.n35
;laser tom mid
  ld [hl],1
  inc hl
  ld a,[l_fx_volume]
  or 1
  ld [hl+],a
  ld [hl],$59
  inc hl
  ld [hl],$80
  ret
.n35:
  cp 6
  jr nz,.n36
;laser tom low
  ld [hl],1
  inc hl
  ld a,[l_fx_volume]
  or 1
  ld [hl+],a
  ld [hl],$5a
  inc hl
  ld [hl],$80
  ret
.n36:
;strange reflect
  ld [hl],1
  inc hl
  ld a,[l_fx_volume]
  or 3
  ld [hl+],a
  ld [hl],$4f
  inc hl
  ld [hl],$80
  ret

;VOICES

l_voice0:
  xor a
  call l_voice_start
  ld a,[l_gb_freq]
  ld b,0
  add a,a
  ld c,a
  ld hl,l_frequencies
  add hl,bc
  ld a,[hl+]
  ld [l_freqLOW],a
  ld a,[hl]
  and $7
  ld [l_freqHI],a
  ld [l_freqHI_v1],a
  call l_instru_test
  ld a,$ee
  ld [rNR51],a
  ld a,[l_snd_swp0]
  ld [rNR10],a
  ld a,[l_snd_lngh0]
  ld [rNR11],a
  ld a,[l_snd_env0]
  ld [rNR12],a
  ld a,[l_freqLOW]
  ld [rNR13],a
  ld a,[l_snd_cons0]
  ld b,a
  ld a,[l_freqHI]
  or b
  ld [rNR14],a
  ld hl,l_fx_pan0
  ld a,0
  or [hl];p0
  inc hl
  or [hl];p1
  inc hl
  or [hl];p2
  inc hl
  or [hl];p3
  ld [rNR51],a
  ret

l_voice1:
  ld a,1
  call l_voice_start
  ld a,[l_gb_freq]
  ld b,0
  add a,a
  ld c,a
  ld hl,l_frequencies
  add hl,bc
  ld a,[hl+]
  ld [l_freqLOW],a
  ld a,[hl]
  and $7
  ld [l_freqHI],a
  ld [l_freqHI_v2],a
  call l_instru_test
  ld a,$dd
  ld [rNR51],a
  ld a,[l_snd_lngh1]
  ld [rNR21],a
  ld a,[l_snd_env1]
  ld [rNR22],a
  ld a,[l_freqLOW]
  ld [rNR23],a
  ld a,[l_snd_cons1]
  ld b,a
  ld a,[l_freqHI]
  or b
  ld [rNR24],a
  ld hl,l_fx_pan0
  ld a,0
  or [hl];p0
  inc hl
  or [hl];p1
  inc hl
  or [hl];p2
  inc hl
  or [hl];p3
  ld [rNR51],a
  ret

l_voice2:
  ld a,2
  call l_voice_start
  ld a,[l_gb_freq]
  ld b,0
  add a,a
  ld c,a
  ld hl,l_frequencies
  add hl,bc
  ld a,[hl+]
  ld [l_freqLOW],a
  ld a,[hl]
  and $7
  ld [l_freqHI],a
  ld a,$bb
  ld [rNR51],a
  xor a
  ld [rNR30],a
  ld [rNR34],a
  call l_instru_test
  ld a,$ff
  ld [rNR31],a
  ld a,[l_fx_volume]
  ld [rNR32],a
  ld a,$80
  ld [rNR30],a
  ld a,[l_freqLOW]
  ld [rNR33],a
  ld a,[l_freqHI]
  or $80
  ld [rNR34],a
  ld hl,l_fx_pan0
  ld a,0
  or [hl];p0
  inc hl
  or [hl];p1
  inc hl
  or [hl];p2
  inc hl
  or [hl];p3
  ld [rNR51],a
  ret

l_voice3:
  ld a,3
  call l_voice_start
  call l_instru_test
  ld a,$77
  ld [rNR51],a
  ld hl,l_snd_lngh3
  ld de,rNR41

  ld a,[hl+]
  ld [de],a
  inc de
  ld a,[hl+]
  ld [de],a
  inc de
  ld a,[hl+]
  ld [de],a
  inc de
  ld a,[hl+]
  ld [de],a
  ld hl,l_fx_pan0
  ld a,0
  or [hl];p0
  inc hl
  or [hl];p1
  inc hl
  or [hl];p2
  inc hl
  or [hl];p3
  ld [rNR51],a
  ret

l_patern_definition:
  ld a,[l_patern]
  ld hl,l_order_table
  ld b,0
  add a,a
  ld c,a
  rl b
  add hl,bc
  ld a,[hl+]
  ld e,a
  ld d,[hl]
  ld hl,l_data_song_ptr
  ld [hl],e
  inc hl
  ld [hl],d
  ret

l_initdataL:
   ld hl,l_initdata
   ld	A,$4C
   ld	[hl+],A
   ld	A,$45
   ld	[hl+],A
   ld	A,$4D
   ld	[hl+],A
   inc	A
   inc	A
   ld	[hl+],A
   dec	A
   ld	[hl],A
   ret

l_wave:
db        $FF,$FF,$FF,$FF,$FF,$FD,$CB,$A8,$75,$43,$21,$00,$00,$00,$00,$00
db        $FF,$FF,$FF,$FF,$B7,$42,$23,$46,$9B,$CD,$DB,$84,$00,$00,$00,$00
db        $FF,$89,$CB,$88,$BA,$78,$99,$77,$88,$66,$78,$54,$77,$43,$67,$00
db        $F8,$B8,$A9,$99,$89,$89,$88,$78,$78,$78,$77,$67,$66,$65,$74,$70
db        $9B,$DE,$EF,$FF,$FF,$FE,$ED,$B9,$64,$22,$10,$00,$00,$01,$22,$46
db        $AD,$FF,$FF,$FF,$FF,$FF,$FF,$DA,$52,$00,$00,$00,$00,$00,$00,$25
db        $FF,$FE,$DD,$CC,$BB,$AA,$99,$88,$77,$66,$55,$44,$33,$22,$10,$00
db        $BE,$EC,$BA,$98,$76,$54,$31,$14,$BE,$EC,$BA,$98,$76,$54,$31,$14

l_frequencies:
dw    44, 156, 262, 363, 457, 547, 631, 710, 786, 854, 923, 986
dw  1046, 1102, 1155, 1205, 1253, 1297, 1339, 1379, 1417, 1452, 1486, 1517
dw  1546, 1575, 1602, 1627, 1650, 1673, 1694, 1714, 1732, 1750, 1767, 1783
dw  1798, 1812, 1825, 1837, 1849, 1860, 1871, 1881, 1890, 1899, 1907, 1915
dw  1923, 1930, 1936, 1943, 1949, 1954, 1959, 1964, 1969, 1974, 1978, 1982
dw  1985, 1988, 1992, 1995, 1998, 2001, 2004, 2006, 2009, 2011, 2013, 2015



SECTION "LemonVars",BSS
l_initdata        ds 5
l_fx_pan0         ds 1
l_fx_pan1         ds 1
l_fx_pan2         ds 1
l_fx_pan3         ds 1
l_snd_swp0        ds 1
l_snd_lngh0       ds 1
l_snd_env0        ds 1
l_snd_cons0       ds 1
l_snd_lngh1       ds 1
l_snd_env1        ds 1
l_snd_cons1       ds 1
l_snd_lngh3       ds 1
l_snd_env3        ds 1
l_snd_poly3       ds 1
l_snd_cons3       ds 1
l_nbr_patern      ds 1
l_patern          ds 1
l_voice           ds 1
l_data_song_ptr   ds 2
l_data_song       ds 2
l_gb_freq         ds 1
l_freqHI          ds 1
l_freqLOW         ds 1
l_fx_volume       ds 1
l_fx_value        ds 1
l_step            ds 1
l_clock           ds 1
l_freqHI_v1	  ds 1
l_freqHI_v2	  ds 1